import com.github.sbt.git.SbtGit.git
import sbt.KeyRanks.BSetting
import sbt.Keys._
import sbt.{Compile, Def, IO, Task, settingKey, taskKey, _}

import java.io.File
import java.time.format.DateTimeFormatter
import java.time.{LocalDateTime, ZoneOffset, ZonedDateTime}
import scala.language.postfixOps

object Version {
  val TIME_OFFSET = 1500000000 //Do not change this with out really thinking about it

  val major = settingKey[String]("semver major version").withRank(BSetting)
  val minor = settingKey[String]("semver minor version").withRank(BSetting)
  val patch = settingKey[String]("semver patch version").withRank(BSetting)
  val build = settingKey[String]("semver build version").withRank(BSetting)

  val writeVersionCode = taskKey[Seq[File]]("write generated version file")
  val writeVersionConf = taskKey[Seq[File]]("write generated version conf file")

  val dateTimeFormatter: DateTimeFormatter = DateTimeFormatter.ofPattern("yyyy-MM-dd'T'HH:mm:ssZ")
  val currentZonedDateTime: ZonedDateTime = ZonedDateTime.now()

  def init(majorNum: String, minorNum: String, patchNum: String): Seq[Def.Setting[_]] = {
    Seq(
      major := majorNum,
      minor := minorNum,
      patch := patchNum,
      build := buildNum(
      git.gitHeadCommitDate.value,
      git.gitHeadCommit.value,
      git.gitUncommittedChanges.value
      ),
      version := s"${major.value}.${minor.value}.${patch.value}.${build.value}",
      writeVersionCode := generateVersionCodeFile().value,
      writeVersionConf := generateVersionConfFile().value,
      Compile / sourceGenerators += writeVersionCode,
      Compile / resourceGenerators += writeVersionConf
    )
  }

  private def shortHash(commitHash: Option[String]): String = {
    commitHash.get.substring(0, 7)
  }

  private def buildTimeNum(commitDate: Option[String]): String = {
    val epoch = LocalDateTime.parse(
      commitDate.get, dateTimeFormatter
    ).atZone(ZoneOffset.UTC).toInstant.toEpochMilli / 1000

    s"${epoch - TIME_OFFSET}"
  }

  def buildNum(commitDate: Option[String], commitHash: Option[String], uncommittedChanges: Boolean): String = {
    if (uncommittedChanges || !sys.env.contains("CI")) {
      // Always use SNAPSHOTTs when producing artifacts outside of gitlab pipelines
      if (sys.env.contains("DEVLAB")) {
        // A debian package DOES NOT get overwritten when posting a debian to the Aptly 'repo' container in devlab
        // if the version already exists in the repo. When a developer sets the "DEVLAB" environment variable, use
        // "now()" instead of commitDate to produce a unique (like a build number), newer version for each packaged
        // artifact. Apt will then see that an upgrade is available and devlab nodes can be patched/updated
        // to include features/fixes that need to be tested in a devlab environment before they can/should be
        // promoted to team/QA/production environments. This logic will NOT execute in gitlab pipelines, because
        // gitlab always builds from fresh clones.
        val snapshotTimestamp = buildTimeNum(Option(currentZonedDateTime.format(dateTimeFormatter)))
        s"0-SNAPSHOT.$snapshotTimestamp"
      } else {
        "0-SNAPSHOT"
      }
    }
    else {
      s"${buildTimeNum(commitDate)}.${shortHash(commitHash)}"
    }
  }

  def generateVersionCodeFile(): Def.Initialize[Task[Seq[File]]] = {
    Def.task {
      val file = (Compile / sourceManaged).value  / "com" / "evernym" / "endorser" / "application" / "BuiltVersion.scala"
      println("Generated version file: " + file)
      val contents = s"""// Generated by SBT
                        |// Do not edit!
                        |
                        |package com.evernym.endorser.application.health
                        |
                        |
                        |object BuiltVersion {
                        |  val version = Version("${major.value}", "${minor.value}", "${patch.value}", "${build.value}")
                        |}""".stripMargin
      IO.write(file, contents)
      Seq(file)
      Seq(file)
    }
  }

  def generateVersionConfFile(): Def.Initialize[Task[Seq[File]]] = {
    Def.task {
//      val file = managedResourceDirectories
//        .value
//        .find(_.getAbsoluteFile.toString.contains("target"))
//        .map(_ / "app-version.conf")
//        .getOrElse(throw new Exception("Unable to find a managed resource dir"))

      // Not sure why the above don't work but what we want is to put the config file in the main directory
      val file = resourceManaged.value / "main" / "app-version.conf"
      println(s"Generated version conf file: ${file.getAbsoluteFile}")
      val contents =
        s"""
           |# Generated by SBT
           |# Do not edit!
           |
           |endorser.version=${version.value}
           |""".stripMargin
      IO.write(file, contents)
      Seq(file)
    }
  }
}
